"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("./util");
const chalk_1 = __importDefault(require("chalk"));
function default_1() {
    let ok = true;
    const packageInfo = require("../../package.json");
    let info = packageInfo.name +
        "@" +
        packageInfo.version +
        " | Node@" +
        process.version +
        " | " +
        process.platform;
    (0, util_1.logStep)("正在初始化gen环境...");
    console.log(info);
    (0, util_1.logStep)("\n1.检测java环境...");
    if (!(0, util_1.isInstalled)("java", ["-version"])) {
        console.log(chalk_1.default.red("未安装java!"));
        ok = false;
    }
    ok &&= checkAndInstall("2.安装|更新", "yo");
    ok &&= checkAndInstall("3.安装|更新", "generator-cosmic");
    if (ok) {
        console.log(chalk_1.default.green("初始化完毕!"));
    }
    else {
        console.log(chalk_1.default.red("初始化失败!"));
    }
    return ok;
}
exports.default = default_1;
function checkAndInstall(msgPrefix, moduleName) {
    (0, util_1.logStep)("\n" + msgPrefix + moduleName + "...");
    let command = (0, util_1.isNpmModuleInstalled)(moduleName) ? "update" : "install";
    return (0, util_1.exec)("npm " + command + " -g " + moduleName);
}
