"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("./util");
const chalk_1 = __importDefault(require("chalk"));
const fs = require("fs");
//需与 generator-cosmic index.ts 保持一致
const kkgenProjectNameFile = "kk.gen";
function default_1(updateTsLib, appname, mcURL) {
    //这个会卡
    // const child = spawn("cmd", ["/c", "npm", "install"])
    // child.on("exit", code => process.exit(code || 0))
    // child.stdout.on("data", chunk => process.stdout.write(chunk))
    // child.stderr.on("data", chunk => process.stderr.write(chunk))
    //适配参数
    if (appname != undefined &&
        mcURL == undefined &&
        (appname.toLowerCase().includes("http://") ||
            appname.toLowerCase().includes("https://"))) {
        //http://192.168.56.102:8090/appstore/dev_env
        mcURL = appname;
        appname = undefined;
    }
    let updateContent = "jar、webapp";
    if (updateTsLib) {
        updateContent = "kingscript-sdk-lib、" + updateContent;
    }
    (0, util_1.logStep)("正在更新工程环境(" + updateContent + ")...");
    let projectPath = process.cwd().replaceAll("\\", "/");
    let packageJsonPath = "package.json";
    if (fs.existsSync(kkgenProjectNameFile)) {
        //读取yo generator-cosmic用户输入的工程名称。
        if (appname == undefined) {
            appname = fs.readFileSync(kkgenProjectNameFile, { flag: "r" }).toString();
        }
        //用完删除(不可在一个目录同时gen多工程)
        fs.unlinkSync(kkgenProjectNameFile);
    }
    if (appname) {
        packageJsonPath = appname + "/" + packageJsonPath;
        projectPath += "/" + appname;
    }
    if (!fs.existsSync(packageJsonPath)) {
        console.error(chalk_1.default.red("未发现工程：" + projectPath));
        process.exit(1);
    }
    else {
        console.log("工程路径：" + projectPath);
    }
    if (appname) {
        process.chdir(appname);
    }
    //更新ts-lib
    if (updateTsLib) {
        (0, util_1.exec)("npm update");
    }
    console.log("更新jar、webapp...");
    let dist = projectPath + "/runtime";
    let cpAndMainClass = fs
        .readFileSync(dist + "/kk.update", { flag: "r" })
        .toString();
    // 调用java实现更新
    let javaCommand = "java -cp " + dist + "/" + cpAndMainClass + " " + dist;
    if (mcURL != undefined) {
        javaCommand += " " + mcURL;
    }
    //console.log("## exec: " + javaCommand);
    (0, util_1.exec)(javaCommand);
    (0, util_1.logStep)("工程环境更新完毕!");
    return projectPath;
}
exports.default = default_1;
