"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isInstalled = exports.isNpmModuleInstalled = exports.exec = exports.logStep = void 0;
const child_process_1 = require("child_process");
const chalk_1 = __importDefault(require("chalk"));
//const spawn = require('cross-spawn');
function logStep(msg) {
    console.log(chalk_1.default.yellow(msg));
}
exports.logStep = logStep;
function exec(cmd) {
    let command;
    let args = cmd.trim().split(" ");
    if (isWin()) {
        command = "cmd";
        args.unshift("/c");
    }
    else {
        //TODO 未测试
        command = "sh";
    }
    //spawn.sync(cmd, [],{ stdio: 'inherit' })
    const { status, stdout, stderr } = (0, child_process_1.spawnSync)(command, args, {
        stdio: "inherit",
    });
    // const debug = true;
    // if (debug) {
    //   console.log("#" + command + " " + args.join(" "));
    //   console.log("status: " + status);
    //   console.log(
    //     "stdout: " + stdout.toString().replace(/\n+/g, "\n").trim() + "\n"
    //   );
    //   console.log(
    //     "stderr: " + stderr.toString().replace(/\n+/g, "\n").trim() + "\n"
    //   );
    // }
    return status == 0;
}
exports.exec = exec;
function isNpmModuleInstalled(module) {
    return exec("npm ls -g --depth=0 " + module);
}
exports.isNpmModuleInstalled = isNpmModuleInstalled;
function isWin() {
    const os = process.platform;
    if (os == "win32") {
        return true;
    }
    return false;
}
function isInstalled(command, args) {
    return exec(command + " " + args.join(" "));
    // const { status, stdout, stderr } = spawnSync(command, args)
    // if (status === 0) {
    //     //console.log(chalk.green(`[${command}]`))
    //     //console.log(stdout.toString().replace(/\n+/g, "\n").trim() + "\n")
    //     return true
    // }
    // //console.log(chalk.red(`[${command}]`))
    // const message = stderr?.toString().trim() || stdout?.toString().trim()
    // // if (message) {
    // //     console.log(message + "\n")
    // // } else {
    // //     console.log(chalk.gray("未找到\nstatus:" + status + ', err:' + stderr + ', out:' + stdout))
    // // }
    // return false
}
exports.isInstalled = isInstalled;
// export default function () {
//   console.log("TODO 此功能尚不支持(cp jar未生成，此处用临时jar启动...你的环境可能不存在此临时文件，启动不了。)")
//   let java = realPath('java');
//   //TODO gen cp jar
//   let cp = "C:/Users/zzf/AppData/Local/Temp/cp_8yvbjue4yj45ohwql7b48tpht.jar"
//   let args = ["/C", java, "-cp", cp, "kd.cosmic.Application"];
//   const child = spawn('cmd', args)
//   child.on("exit", code => process.exit(code || 0))
//   child.stdout.on("data", chunk => process.stdout.write(chunk))
//   child.stderr.on("data", chunk => process.stderr.write(chunk))
// }
// function realPath(command: string): string {
//   const fullPath = which.sync(command)
//   if (fs.lstatSync(fullPath).isSymbolicLink()) {
//       return fs.realpathSync(fullPath)
//   } else {
//       return fullPath
//   }
// }
