"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = __importDefault(require("chalk"));
const commander_1 = require("commander");
const commands_1 = __importDefault(require("./commands"));
const spawn = require("cross-spawn");
const packageInfo = require("../package.json");
//https://github.com/tj/commander.js/blob/HEAD/Readme_zh-CN.md
commander_1.program
    .version(packageInfo.name + "@" + packageInfo.version)
    .command("init")
    .description("初始化gen环境")
    .action(() => {
    commands_1.default.init();
});
commander_1.program
    .command("gen [projectName] [mcServerURL]")
    .description("创建苍穹工程")
    .action((projectName, mcServerURL) => {
    if (commands_1.default.gen(projectName, mcServerURL)) {
        console.log();
        //此处不再更新ts-lib，在gen时(generator-cosmic中)已经执行更新
        let projectPath = commands_1.default.update(false, projectName);
        //打开vs code
        console.log(chalk_1.default.yellow("打开工程(VSCode)..."));
        spawn("code", [projectPath], {
            stdio: "inherit",
        });
    }
});
commander_1.program
    .command("update [projectName] [mcServerURL]")
    .description("更新工程环境(kingscript-sdk-lib、jar、webapp)")
    .action((projectName, mcServerURL) => {
    commands_1.default.update(true, projectName, mcServerURL);
});
commander_1.program.parse(process.argv);
