/// list、set、map、queue、deque
/// 本接口仅用于编写脚本，由engine.collection.js实现(接入java对象)

/*******************************************
 * Map
 ******************************************/
interface JavaMap<K, V> {
    size(): number;
    isEmpty(): boolean;
    remove(key: K): V | undefined;
    get(key: K): V | undefined;
    put(key: K, value: V): V | undefined;
    //TODO ...
}


/*******************************************
 * HashMap
 ******************************************/
interface HashMap<K, V> extends JavaMap<K, V> {
    //TODO ...
}

// for re-export(空壳) to global: anne-script-lib.ts，用作编码时接口提示。
export interface HashMapConstructor {
    new <K, V>(): HashMap<K, V>;
    new <K, V>(initialCapacity: number, loadFactor?: number): HashMap<K, V>;
    new <K, V>(map: JavaMap<K, V>): HashMap<K, V>;
    //TODO ...
}

// for java engine import，执行时真正的实现类。
export const HashMap: HashMapConstructor = AnneScript.type('java.util.HashMap');


/*******************************************
 * LinkedHashMap
 ******************************************/
interface LinkedHashMap<K, V> extends JavaMap<K, V> {
    //TODO ...
}

export interface LinkedHashMapConstructor {
    new <K, V>(): LinkedHashMap<K, V>;
    //TODO ...
}

export const LinkedHashMap: LinkedHashMapConstructor = AnneScript.type('java.util.LinkedHashMap');



/*******************************************
 * ConcurrentHashMap
 ******************************************/
interface ConcurrentHashMap<K, V> extends JavaMap<K, V> {
    //TODO ...
}

export interface ConcurrentHashMapConstructor {
    new <K, V>(): ConcurrentHashMap<K, V>;
    //TODO ...
}

export const ConcurrentHashMap: ConcurrentHashMapConstructor = AnneScript.type('java.util.concurrent.ConcurrentHashMap');


//TODO ....

// /*******************************************
//  * Map
//  ******************************************/
// export function HashMap() {
//     return AnneScript.type('java.util.HashMap');
// }

// export function HashTable() {
//     return AnneScript.type('java.util.HashTable');
// }

// export function ConcurrentHashMap() {
//     return AnneScript.type('java.util.ConcurrentHashMap');
// }

// export function LinkedHashMap() {
//     return AnneScript.type('java.util.LinkedHashMap');
// }

// export function TreeMap() {
//     return AnneScript.type('java.util.TreeMap');
// }


// /******************************************
//  * List
//  ******************************************/
// export function ArrayList() {
//     return AnneScript.type('java.util.ArrayList');
// }

// export function LinkedList() {
//     return AnneScript.type('java.util.LinkedList');
// }

// export function CopyOnWriteArrayList() {
//     return AnneScript.type('java.util.CopyOnWriteArrayList');
// }

// export function Vector() {
//     return AnneScript.type('java.util.Vector');
// }

// export function Stack() {
//     return AnneScript.type('java.util.Stack');
// }

// export function ArrayDeque() {
//     return AnneScript.type('java.util.ArrayDeque');
// }

// export function LinkedBlockingDeque() {
//     return AnneScript.type('java.util.LinkedBlockingDeque');
// }

// export function PriorityQueue() {
//     return AnneScript.type('java.util.PriorityQueue');
// }

// export function LinkedBlockingQueue() {
//     return AnneScript.type('java.util.LinkedBlockingQueue');
// }

// export function ArrayBlockingQueue() {
//     return AnneScript.type('java.util.ArrayBlockingQueue');
// }

// export function PriorityBlockingQueue() {
//     return AnneScript.type('java.util.PriorityBlockingQueue');
// }


// /******************************************
//  * Set
//  ******************************************/
// export function ConcurrentSkipListSet() {
//     return AnneScript.type('java.util.ConcurrentSkipListSet');
// }

// export function CopyOnWriteArraySet() {
//     return AnneScript.type('java.util.CopyOnWriteArraySet');
// }

// export function HashSet() {
//     return AnneScript.type('java.util.HashSet');
// }

// export function LinkedHashSet() {
//     return AnneScript.type('java.util.LinkedHashSet');
// }

// export function TreeSet() {
//     return AnneScript.type('java.util.TreeSet');
// }

