/*******************************************
 * Date 扩展接口在engine.builtins.d.ts定义
 * @see kd.bos.annescript.engine.AnneScriptEngineImpl#initEngineAll
 ******************************************/
//export const __Date__ = AnneScript.type('kd.bos.annescript.engine.types.builtins.JSDate');


/*******************************************
 * SimpleDateFormat
 ******************************************/
interface SimpleDateFormat {
    format(object: any): string;
    parse(source: string): SimpleDateFormat;
}

export interface SimpleDateFormatConstructor {
    new(): SimpleDateFormat;
    new(pattern: string): SimpleDateFormat;
}

export const SimpleDateFormat: SimpleDateFormatConstructor = AnneScript.type('java.text.SimpleDateFormat');


/*******************************************
 * Calendar
 ******************************************/
interface Calendar {
    get(field: number): number;
    set(field: number, value: number): void;
    clear(): void;
    setTime(date: Date): void;
    //TODO ...
}

export interface CalendarConstructor {
    getInstance(): Calendar;
    //TODO
}

export const Calendar: CalendarConstructor = AnneScript.type('java.util.Calendar');