/**
 * AnneScript内置功能接口
 */

//@see com.oracle.truffle.js.test.builtins.JavaBuiltinsTest
//@see com.oracle.truffle.js.builtins.JavaBuiltins
//包含了nashorn-compat模式的接口(无需启用nashorn-compat模式)，@see kd.bos.annescript.engine.global.GlobalObject#setupAnneInterop
declare class AnneScript {
    static type(name: string): any;
    static typeName(type: any): string;

    static from(...args: any): any;
    static to(jsObject: any, javaType: string): any;

    static extend(type: any): any;  //Java.extend(Java.type("java.lang.Runnable"));
    static super(...args: any): void

    static isType(type: any): boolean;
    static isJavaObject(javaObject: any): boolean;

    // only in nashorn-compat mode @JavaBuiltins
    static isJavaMethod(javaMethod: any): boolean;
    // only in nashorn-compat mode @JavaBuiltins
    static isJavaFunction(javaFunction: any): boolean;
    // only in nashorn-compat mode @JavaBuiltins
    static isScriptFunction(scriptFunction: any): boolean;
    // only in nashorn-compat mode @JavaBuiltins
    static isScriptObject(scriptObject: any): boolean;

    // only in nashorn-compat mode @JavaBuiltins
    static synchronized(functionObject: Function, key: any): void;

    // only in nashorn-compat mode @JavaBuiltins
    static addToClasspath(path: string): void;    
}

declare function load(libPath: string): void;

declare function print(message: any): void;

// 不用java实现，java的Date对比js的Date缺失的方法、属性太多，有些无法提供对等的，如prototype。
// interface Date {
//     before(when: Date): boolean;
//     after(when: Date): boolean;   
// }
